#include "common.h"
#include "palette.h"

// public
const word colorWordMasks[20][8][3] =
{
    {   // Color 00 = 0, 0, 0
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 },
        { 0b0000000000000000, 0b0000000000000000, 0b0000000000000000 }
    },
    {   // Color 01 = 0, 0, 1
        { 0b0000010000010000, 0b0001000001000001, 0b0100000100000100 },
        { 0b0100000100000100, 0b0000010000010000, 0b0001000001000001 },
        { 0b0001000001000001, 0b0100000100000100, 0b0000010000010000 },
        { 0b0000010000010000, 0b0001000001000001, 0b0100000100000100 },
        { 0b0100000100000100, 0b0000010000010000, 0b0001000001000001 },
        { 0b0001000001000001, 0b0100000100000100, 0b0000010000010000 },
        { 0b0000010000010000, 0b0001000001000001, 0b0100000100000100 },
        { 0b0100000100000100, 0b0000010000010000, 0b0001000001000001 }
    },
    {   // Color 02 = 0, 0, 2
        { 0b0000100000100000, 0b0010000010000010, 0b1000001000001000 },
        { 0b1000001000001000, 0b0000100000100000, 0b0010000010000010 },
        { 0b0010000010000010, 0b1000001000001000, 0b0000100000100000 },
        { 0b0000100000100000, 0b0010000010000010, 0b1000001000001000 },
        { 0b1000001000001000, 0b0000100000100000, 0b0010000010000010 },
        { 0b0010000010000010, 0b1000001000001000, 0b0000100000100000 },
        { 0b0000100000100000, 0b0010000010000010, 0b1000001000001000 },
        { 0b1000001000001000, 0b0000100000100000, 0b0010000010000010 }
    },
    {   // Color 03 = 0, 0, 3
        { 0b0000110000110000, 0b0011000011000011, 0b1100001100001100 },
        { 0b1100001100001100, 0b0000110000110000, 0b0011000011000011 },
        { 0b0011000011000011, 0b1100001100001100, 0b0000110000110000 },
        { 0b0000110000110000, 0b0011000011000011, 0b1100001100001100 },
        { 0b1100001100001100, 0b0000110000110000, 0b0011000011000011 },
        { 0b0011000011000011, 0b1100001100001100, 0b0000110000110000 },
        { 0b0000110000110000, 0b0011000011000011, 0b1100001100001100 },
        { 0b1100001100001100, 0b0000110000110000, 0b0011000011000011 }
    },
    {   // Color 04 = 0, 1, 1
        { 0b0001010001010001, 0b0101000101000101, 0b0100010100010100 },
        { 0b0100010100010100, 0b0001010001010001, 0b0101000101000101 },
        { 0b0101000101000101, 0b0100010100010100, 0b0001010001010001 },
        { 0b0001010001010001, 0b0101000101000101, 0b0100010100010100 },
        { 0b0100010100010100, 0b0001010001010001, 0b0101000101000101 },
        { 0b0101000101000101, 0b0100010100010100, 0b0001010001010001 },
        { 0b0001010001010001, 0b0101000101000101, 0b0100010100010100 },
        { 0b0100010100010100, 0b0001010001010001, 0b0101000101000101 }
    },
    {   // Color 05 = 0, 1, 2
        { 0b0001100001100001, 0b0110000110000110, 0b1000011000011000 },
        { 0b1000011000011000, 0b0001100001100001, 0b0110000110000110 },
        { 0b0110000110000110, 0b1000011000011000, 0b0001100001100001 },
        { 0b0001100001100001, 0b0110000110000110, 0b1000011000011000 },
        { 0b1000011000011000, 0b0001100001100001, 0b0110000110000110 },
        { 0b0110000110000110, 0b1000011000011000, 0b0001100001100001 },
        { 0b0001100001100001, 0b0110000110000110, 0b1000011000011000 },
        { 0b1000011000011000, 0b0001100001100001, 0b0110000110000110 }
    },
    {   // Color 06 = 0, 1, 3
        { 0b0001110001110001, 0b0111000111000111, 0b1100011100011100 },
        { 0b1100011100011100, 0b0001110001110001, 0b0111000111000111 },
        { 0b0111000111000111, 0b1100011100011100, 0b0001110001110001 },
        { 0b0001110001110001, 0b0111000111000111, 0b1100011100011100 },
        { 0b1100011100011100, 0b0001110001110001, 0b0111000111000111 },
        { 0b0111000111000111, 0b1100011100011100, 0b0001110001110001 },
        { 0b0001110001110001, 0b0111000111000111, 0b1100011100011100 },
        { 0b1100011100011100, 0b0001110001110001, 0b0111000111000111 }
    },
    {   // Color 07 = 0, 2, 2
        { 0b0010100010100010, 0b1010001010001010, 0b1000101000101000 },
        { 0b1000101000101000, 0b0010100010100010, 0b1010001010001010 },
        { 0b1010001010001010, 0b1000101000101000, 0b0010100010100010 },
        { 0b0010100010100010, 0b1010001010001010, 0b1000101000101000 },
        { 0b1000101000101000, 0b0010100010100010, 0b1010001010001010 },
        { 0b1010001010001010, 0b1000101000101000, 0b0010100010100010 },
        { 0b0010100010100010, 0b1010001010001010, 0b1000101000101000 },
        { 0b1000101000101000, 0b0010100010100010, 0b1010001010001010 }
    },
    {   // Color 08 = 0, 2, 3
        { 0b0010110010110010, 0b1011001011001011, 0b1100101100101100 },
        { 0b1100101100101100, 0b0010110010110010, 0b1011001011001011 },
        { 0b1011001011001011, 0b1100101100101100, 0b0010110010110010 },
        { 0b0010110010110010, 0b1011001011001011, 0b1100101100101100 },
        { 0b1100101100101100, 0b0010110010110010, 0b1011001011001011 },
        { 0b1011001011001011, 0b1100101100101100, 0b0010110010110010 },
        { 0b0010110010110010, 0b1011001011001011, 0b1100101100101100 },
        { 0b1100101100101100, 0b0010110010110010, 0b1011001011001011 }
    },
    {   // Color 09 = 0, 3, 3
        { 0b0011110011110011, 0b1111001111001111, 0b1100111100111100 },
        { 0b1100111100111100, 0b0011110011110011, 0b1111001111001111 },
        { 0b1111001111001111, 0b1100111100111100, 0b0011110011110011 },
        { 0b0011110011110011, 0b1111001111001111, 0b1100111100111100 },
        { 0b1100111100111100, 0b0011110011110011, 0b1111001111001111 },
        { 0b1111001111001111, 0b1100111100111100, 0b0011110011110011 },
        { 0b0011110011110011, 0b1111001111001111, 0b1100111100111100 },
        { 0b1100111100111100, 0b0011110011110011, 0b1111001111001111 }
    },
    {   // Color 10 = 1, 1, 1
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 },
        { 0b0101010101010101, 0b0101010101010101, 0b0101010101010101 }
    },
    {   // Color 11 = 1, 1, 2
        { 0b0101100101100101, 0b0110010110010110, 0b1001011001011001 },
        { 0b1001011001011001, 0b0101100101100101, 0b0110010110010110 },
        { 0b0110010110010110, 0b1001011001011001, 0b0101100101100101 },
        { 0b0101100101100101, 0b0110010110010110, 0b1001011001011001 },
        { 0b1001011001011001, 0b0101100101100101, 0b0110010110010110 },
        { 0b0110010110010110, 0b1001011001011001, 0b0101100101100101 },
        { 0b0101100101100101, 0b0110010110010110, 0b1001011001011001 },
        { 0b1001011001011001, 0b0101100101100101, 0b0110010110010110 }
    },
    {   // Color 12 = 1, 1, 3
        { 0b0101110101110101, 0b0111010111010111, 0b1101011101011101 },
        { 0b1101011101011101, 0b0101110101110101, 0b0111010111010111 },
        { 0b0111010111010111, 0b1101011101011101, 0b0101110101110101 },
        { 0b0101110101110101, 0b0111010111010111, 0b1101011101011101 },
        { 0b1101011101011101, 0b0101110101110101, 0b0111010111010111 },
        { 0b0111010111010111, 0b1101011101011101, 0b0101110101110101 },
        { 0b0101110101110101, 0b0111010111010111, 0b1101011101011101 },
        { 0b1101011101011101, 0b0101110101110101, 0b0111010111010111 }
    },
    {   // Color 13 = 1, 2, 2
        { 0b0110100110100110, 0b1010011010011010, 0b1001101001101001 },
        { 0b1001101001101001, 0b0110100110100110, 0b1010011010011010 },
        { 0b1010011010011010, 0b1001101001101001, 0b0110100110100110 },
        { 0b0110100110100110, 0b1010011010011010, 0b1001101001101001 },
        { 0b1001101001101001, 0b0110100110100110, 0b1010011010011010 },
        { 0b1010011010011010, 0b1001101001101001, 0b0110100110100110 },
        { 0b0110100110100110, 0b1010011010011010, 0b1001101001101001 },
        { 0b1001101001101001, 0b0110100110100110, 0b1010011010011010 }
    },
    {   // Color 14 = 1, 2, 3
        { 0b0110110110110110, 0b1011011011011011, 0b1101101101101101 },
        { 0b1101101101101101, 0b0110110110110110, 0b1011011011011011 },
        { 0b1011011011011011, 0b1101101101101101, 0b0110110110110110 },
        { 0b0110110110110110, 0b1011011011011011, 0b1101101101101101 },
        { 0b1101101101101101, 0b0110110110110110, 0b1011011011011011 },
        { 0b1011011011011011, 0b1101101101101101, 0b0110110110110110 },
        { 0b0110110110110110, 0b1011011011011011, 0b1101101101101101 },
        { 0b1101101101101101, 0b0110110110110110, 0b1011011011011011 }
    },
    {   // Color 15 = 1, 3, 3
        { 0b0111110111110111, 0b1111011111011111, 0b1101111101111101 },
        { 0b1101111101111101, 0b0111110111110111, 0b1111011111011111 },
        { 0b1111011111011111, 0b1101111101111101, 0b0111110111110111 },
        { 0b0111110111110111, 0b1111011111011111, 0b1101111101111101 },
        { 0b1101111101111101, 0b0111110111110111, 0b1111011111011111 },
        { 0b1111011111011111, 0b1101111101111101, 0b0111110111110111 },
        { 0b0111110111110111, 0b1111011111011111, 0b1101111101111101 },
        { 0b1101111101111101, 0b0111110111110111, 0b1111011111011111 }
    },
    {   // Color 16 = 2, 2, 2
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 },
        { 0b1010101010101010, 0b1010101010101010, 0b1010101010101010 }
    },
    {   // Color 17 = 2, 2, 3
        { 0b1010111010111010, 0b1011101011101011, 0b1110101110101110 },
        { 0b1110101110101110, 0b1010111010111010, 0b1011101011101011 },
        { 0b1011101011101011, 0b1110101110101110, 0b1010111010111010 },
        { 0b1010111010111010, 0b1011101011101011, 0b1110101110101110 },
        { 0b1110101110101110, 0b1010111010111010, 0b1011101011101011 },
        { 0b1011101011101011, 0b1110101110101110, 0b1010111010111010 },
        { 0b1010111010111010, 0b1011101011101011, 0b1110101110101110 },
        { 0b1110101110101110, 0b1010111010111010, 0b1011101011101011 }
    },
    {   // Color 18 = 2, 3, 3
        { 0b1011111011111011, 0b1111101111101111, 0b1110111110111110 },
        { 0b1110111110111110, 0b1011111011111011, 0b1111101111101111 },
        { 0b1111101111101111, 0b1110111110111110, 0b1011111011111011 },
        { 0b1011111011111011, 0b1111101111101111, 0b1110111110111110 },
        { 0b1110111110111110, 0b1011111011111011, 0b1111101111101111 },
        { 0b1111101111101111, 0b1110111110111110, 0b1011111011111011 },
        { 0b1011111011111011, 0b1111101111101111, 0b1110111110111110 },
        { 0b1110111110111110, 0b1011111011111011, 0b1111101111101111 }
    },
    {   // Color 19 = 3, 3, 3
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 },
        { 0b1111111111111111, 0b1111111111111111, 0b1111111111111111 }
    }
};

void setPalette()
{
    // 0x3C = Red   = 00 111 100 (R=11, G=10, B=10)
    // 0x3A = Green = 00 111 010 (R=10, G=11, B=10)
    // 0x39 = Blue  = 00 111 001 (R=10, G=10, B=11)

    // 0x27 = Red   = 00 100 111 (R=11, G=01, B=01)
    // 0x17 = Green = 00 010 111 (R=01, G=11, B=01)
    // 0x0F = Blue  = 00 001 111 (R=01, G=01, B=11)

    // 0x24 = Red   = 00 100 100 (R=11, G=00, B=00)
    // 0x12 = Green = 00 010 010 (R=00, G=11, B=00)
    // 0x09 = Blue  = 00 001 001 (R=00, G=00, B=11)
    pokeWord(0xFFB0, 0x0027);
    pokeWord(0xFFB2, 0x170F);
}
